#include <stdio.h>
#include <math.h>

#define pi (4.*atan(1.))
#define N 9
#define D 1.
#define r 0.2

 /* This is Crank-Nicolson method */

void main()
{
   double dx,x,t,dt,err[N+1]={0.0},truef[N+1]={0.0};
   double s=0.;
   double m[N+1][N+1]={0.0},h[N+1][N+1]={0.};
   double fnew[N+1]={0.},b[N+1]={0.0};
   double fold[N+1]={0.0};
   double koon,sum;
   int i,j,k,l,n,a;

   t = 0.;
   dx =0.1;
   dt = (0.2*dx*dx)/D ;
   s = r/2.;
   /* initial condition */
   for (i=1;i<=N;i++) {
      x = i*dx;
      fold[i] = sin(pi*x) + sin(2.*pi*x)/2.;
   }
      /* check fold[i]*/
      for(i=1;i<=N;i++) printf("fold[%d] = %lf\n",i,fold[i]);
      /* coefficient matrix h[i][j] */
      for (i=1;i<=N;i++) h[i][i] = 1.-(2.*s);
      for (i=2;i<=N;i++) h[i][i-1] = s;
      for (i=1;i<=N-1;i++) h[i][i+1] = s;
   /* solving for fnew[i] */
   for (a=1;a<=500;a++) {
      t = a*dt;

      /* b[i] for new step */
      for (i=1;i<=N;i++) b[i] = 0.;
      for (i=1;i<=N;i++) {
	 for (j=1;j<=N;j++) b[i] += h[i][j]*fold[i];
      }
      /* check b[i]*/
  //    for(i=1;i<=N;i++) printf("b[%d] = %lf\n",i,b[i]);

      /* coefficient matrix m[i][j] */
      for (i=1;i<=N;i++) m[i][i] = 1.+(2.*s);
      for (i=2;i<=N;i++) m[i][i-1] = -s;
      for (i=1;i<=N-1;i++) m[i][i+1] = -s;

      for (i=1;i<=N;i++) {
	 for (k=i+1;k<=N;k++) {
	    koon = - m[k][i] / m[i][i];
	    for (j=i+1;j<=N;j++) m[k][j] += koon * m[i][j];
	    b[k] += koon * b[i];
	 }
      }

      /* back subtitution */
      for (i=N;i>=1;i--) {
	 sum = 0.0;
	 for (j=i+1;j<=N;j++) sum += m[i][j] * fnew[j];
	 fnew[i] = (b[i] - sum )/ m[i][i] ;
      }
      /* check fnew[i]*/
//      for(i=1;i<=N;i++) printf("fold[%d] = %lf   fnew[%d] = %lf\n",i,fold[i],i,fnew[i]);

      /* finding err */
      for (i=1;i<=N;i++) {
	 x = i*dx;
	 truef[i] = (sin(pi*x)*exp(-pi*pi*D*t)) + (sin(2.*pi*x)*exp(-4.*pi*pi*D*t))/2.;
	 err[i] = fabs(truef[i]-fnew[i]);
      }

      /* test if t=0.1D,... if true printf */
      if ( a%50 ==0 ) {
	 for (i=1;i<=N;i++)
	 printf ("fn[t%.2lf][x%d]=%.8lf   truef[%d]=%.8lf   err[%d]=%.8lf\n",t,i,fnew[i],i,truef[i],i,err[i]);
      }
       for(i=1;i<=N;i++) fold[i] = fnew[i] ;
   }
}











