/*
   By Paisan Tooprakai
   ctos.c -- 21 September 2005
      Transform cartesian coor. to spherical coor. 
         r = sqrt(x^2+y^2+z^2)
         theta = atan(sqrt(x^2+y^2)/z) = acos(z/r)
         phi = atan(y/x)
         vr = vx*sin(\theta)*cos(\phi)+vy*sin(\theta)*sin(\phi)
              +vz*cos(\theta)
         vtheta = vx*cos(\theta)*cos(\phi)+vy*cos(\theta)*sin(\phi)
              -vz*sin(\theta)
         vphi = vy*cos(\phi)-vx*sin(\phi)
    
      input file -> rctos.nmf
      output file -> wctos.nmf

*/

#include<stdio.h>
#include<math.h>

#define PI (4.0*atan(1.0))

main()
{
   int    i, no;   
   int    rfile, wfile;
   char   nfpi[80][25],nfpo[80][25];
   double x, y, z;
   double xx, yy, zz;
   double r, theta, phi;
   double rdot, thetadot, phidot; 
   double rr, theta1, phi1; 
   FILE   *fpo,*fpw,*fp1,*fopen();

   
   if((fp1=fopen("rctos.nmf","r"))==NULL) {
      printf("Error to open rctos.nmf file.\n");
      exit(1);
   }
   for(rfile=0;;rfile++) { /* Count and read file name for reading. */
      if(feof(fp1)==0) {
         fscanf(fp1,"%s",&nfpi[rfile]);
         printf("%s\n",nfpi[rfile]);
      } else {
         break;
      }
   }
   rfile--;
   close(fp1);

   if((fp1=fopen("wctos.nmf","r"))==NULL) {
      printf("Error to open wctos.nmf file.\n");
      exit(1);
   }
   for(wfile=0;;wfile++) { /* Count and read file name for saving. */
      if(feof(fp1)==0) {
         fscanf(fp1,"%s",&nfpo[wfile]);
         printf("%s\n",nfpo[wfile]);
      } else {
         break;
      }
   }
   wfile--;
   close(fp1);

   if(rfile!=wfile) {  /* Check No. of reading and writting file must be equal. */
      printf("No.%d of files for reading are not equal with No.%d of file for writting.\n",rfile,wfile);
      exit(1);
   }
  
   for(i=0;i<wfile;i++) {
      if((fpo=fopen(nfpi[i],"r"))==NULL) {
         printf("Error open %s file for reading.\n",nfpi[i]);
      }
      if((fpw=fopen(nfpo[i],"w"))==NULL) {
         printf("Error open %s file for writting.\n",nfpo[i]);
      }
      for(;;) {
            fscanf(fpo,"%d %lf %lf %lf %lf %lf %lf",&no,&x,&y,&z,&xx,&yy,&zz);
         if(feof(fpo)==0) {
/* printf("%d %lf %lf %lf %lf %lf %lf\n",no,x,y,z,xx,yy,zz); */

            r = sqrt((x*x)+(y*y)+(z*z));
            theta = atan(sqrt((x*x)+(y*y))/z);
            if(x<0.0) phi = PI+atan(y/x);
            else phi = atan(y/x);

            rr = sqrt((xx*xx)+(yy*yy)+(zz*zz));
            theta1 = atan(sqrt((x*x)+(y*y))/zz);
            if(x<0.0) phi1 = PI+atan(yy/xx);
            else phi1 = atan(yy/xx);

/* printf("%lf %lf %lf %lf\n",sin(theta),cos(theta),sin(phi),cos(phi)); */

           fprintf(fpw,"%5d %12.6lf %12.6lf %12.6lf %12.6lf %12.6lf %12.6lf\n",no,phi,theta,r,phi1,theta1,rr);
         } else {
            break;
         }
      }
      fclose(fpo);
      fclose(fpw);
   }
printf("i = %d\n",i--);
}

